/**  Using clipboard - needs a recent version - Chrome is OK - 
 CLICK A COLOR, = COPY to Clipboard */

var nColors = 1819, mousex, mousey, GG, Width = 1260, patchSize = 20, HSV = 0;
document.onmousedown = mouseDwn;
//document.onmouseup = mUp;
//document.onmousemove = mRoll;
//document.onkeydown = keyDwn;

function load() {
  var jg = new jsGraphics("Canvas");
  GG=jg;
  jg.setStroke(1);
  jg.setColor("#999999");
  var dc = document;
  hidectrl(dc.getElementById("stats"));
  drawpalette();
}
function drawpalette() {
  var w = Width, dc = document;
  var e = dc.getElementById("stats");
  var s = "Hello World";

  dc.statss.statwin.value = s;
  if (e.style.visibility == "hidden") showctrl(e);
  dc.getElementById("colorname").value = " Drawing "+nColors+" Colors";
  var i;
  for (i=0;i < nColors; i++) colorpatch(i,w);

  GG.paint();
  dc.getElementById("colorname").value = " Finished Drawing "+nColors+" Colors";
}
function showctrl(dcp) {
  dcp.style.visibility = "visible";
}
function hidectrl(dcp) {
  dcp.style.visibility = "hidden";
}

function hidestatwin() {
  hidectrl(document.getElementById("stats"));
}

function echoadd() {
  var dc = document;
  var e = dc.getElementById("stats")
  var arg = arguments, i = 0, s = "";
  for (i=0;i<arg.length;i++) s = s + " " + arg[i];
  dc.statss.statwin.value =
  dc.statss.statwin.value + s.toString();
  if (e.style.visibility == "hidden") showctrl(e);
  // if (timmm) clearTimeout(timmm);
}
function echo(s) {
  document.statss.statwin.value = s.toString();
}

function mouseDwn(e) {
  var IE = 0;
  var b = IE? event.button: e.which;
  var shft = IE? event.shiftKey:e.shiftKey;
  if (b == 1) {
    var d;
    if (IE) {  // IE case e.pageX == null
      d= (document.documentElement && 
      document.documentElement.scrollLeft != null) ?
      document.documentElement : document.body;
      mousex= event.clientX + d.scrollLeft;
      mousey= event.clientY + d.scrollTop;
    } 
    else { mousex= e.pageX; mousey= e.pageY; }
    mousey = mousey - 22;

  var m = Math.floor(Width/patchSize);
  if ((mousex < (patchSize * m)) && (mousey > 0)) {
    echo(" ");
    m = whichcolor();
    patchHighLight(m);
    if (HSV) bufferhue(m);
    else buffer(m);
   }
  }
  return true;
}
function clamp(a,n,m) {
  if (a < n) return n;
  if (a > m) return m;
  return a;
}
function buffer(i) {
  var n = clamp(i, 0, nColors-1);
  document.getElementById("colorname").value = color[n];
  clipboard();
}
function bufferhue(i) {
  var n = clamp(i, 0, nColors-1);
  document.getElementById("colorname").value = colorhue(i);
//  clipboard();
}
function whichcolor() {
  var m = Math.floor(Width/patchSize);
  if (mousex > (patchSize * m)) { echo("off edge"); return 0; }
  if (mousey < 0) { echo("before edge"); return 0; }

  var x = Math.floor(mousex/patchSize);
  var y = Math.floor(mousey/patchSize);
  var i = m * y + x;
  if (i >= nColors) echo("No more colors.");
  return i;
}
/// THUMB NAIL
function colorpatch(i,w) {
  var sz = patchSize, c = "#000000";
  var s = color[i];
  var t = s.split(" ");
  if (t[3] == "White*") c = float2hex(t[4]);
  if ((t.length == 5) && (i < 9)) c = float2hex(t[4]);
  else if ((t[3] == "color") && (t[4] == "red")) c = color2hex(t[5],t[7],t[9]);
  else if ((t[3] == "color") && (t[4] == "rgb")) c = arr2hex(t[5],t[6],t[7]);
  else if (t[3] == "rgb") c = arr2hex(t[4],t[5],t[6]);

// "#declare MediumSlateBlue = color red 0.498039 green 0.5 blue 1.0;" ,
// "#declare MediumSpringGreen = color red 0.498039 green 1.0 blue 0.5;" ,
// had no green blue --- yellow had no spaces
// ? "#declare Mica = color Black; // needed in textures.inc" , fits nothing
//"#declare OrangeRed = color red 1.0 green 0.25 blue 0.0;" no blue
// document.getElementById("colorname").value = c;

  var m = Math.floor(w/sz);
  var x = (i % m) * sz;
  var y = Math.floor(i / m) * sz;
  GG.setColor(c);
  GG.fillRect(x,y,sz,sz);
}
function patchHighLight(i) {
  var w = Width, sz = patchSize;
  var m = Math.floor(w/sz);
  var x = (i % m) * sz;
  var y = Math.floor(i / m) * sz;
  GG.setColor("#FFFFFF");
  GG.drawRect(x,y,sz,sz);
 GG.paint();
}
function float2hex(a) {
  var b = Math.floor(parseFloat("" + a)*255.0);
  var c = new Array(b,b,b);
  return RGB2Hex(c);
}
function color2hex(a,b,c) {
  var c = new Array(Math.floor(parseFloat(a)*255.0),
  Math.floor(parseFloat(b)*255.0),
  Math.floor(parseFloat(c)*255.0));
  return RGB2Hex(c);
}
function arr2hex(a,b,c) {
  var d = a, e = b, f = c;
  if (a.substr(0,1) == "<") {
    d = a.substr(1);
  }
  var c = new Array(Math.floor(parseFloat(d)*255.0),
  Math.floor(parseFloat(e)*255.0),
  Math.floor(parseFloat(f)*255.0));
  return RGB2Hex(c);
}

function _String() {
  var arg = arguments, i = 0, s = "";
  for (i=0;i<arg.length;i++) s = s + " " + arg[i];
  return s;
}
function intr(num) {
  var n = Math.floor(Math.abs(num));
  if (num < 0) n = n * -1;
  return n;
}
function RGB2Hex(n) { // n = array(3) or string with commas
  var d2h="", a, b;
  if (n.length == 3) n = _String(n); // args for _String() = 1;
  var rgb = n.split(","); // string array becomes 1,1,1 automatically
  // and parseInt not needed for rgb[i]
  var hexa = new Array("0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F");
  for (var i=0;i<3;i++) {
    a = Math.floor(rgb[i] / 16);
    b = intr(rgb[i]) - a * 16;
    d2h += hexa[a];
    d2h += hexa[b];
  }
  return "#"+d2h;
}
/// H,S,L in range of 0-1
function hsl2rgb(hh, s, l) {
  var v, r = 0,g = 0,b = 0;
  if (l <= 0.5) v = (l * (1.0 + s));
  else v = (l + s - l * s);

  if (v > 0) {
    var sextant;
    var fract, vsf, mid1, mid2, m, sv;
    m = l + l - v;
    sv = (v - m ) / v;

    var h = hh;
//   if (h == 1.0) h = 1.0 - (1.0/nColors);
   
    sextant = intr(h*6.0);
    fract = (h*6.0) - sextant;
    vsf = v * sv * fract;
    mid1 = m + vsf;
    mid2 = v - vsf;
    switch (sextant) {
      case 0: r = v;g = mid1;b = m;
      break;
      case 1: r = mid2;g = v;b = m;
      break;
      case 2: r = m;g = v;b = mid1;
      break;
      case 3: r = m;g = mid2;b = v;
      break;
      case 4: r = mid1;g = m;b = v;
      break;
      case 5: r = v;g = m;b = mid2;
      break;
      case 6: r = 0;g = 0;b = 0;
      break;
    }
  }
// also giving negative numbers ?!?
return new Array(clamp(rnd(r,5),0,1),
    clamp(rnd(g,5),0,1),clamp(rnd(b,5),0,1));
  return new Array(r,g,b);
}
function minimum(a,b) {
  if (a < b) return a;
  if (b < a) return b;
  return a;
}
function h2rgb(hu) {
  var h = (hu * 360.0) % 360;
  var r = 0, g = 0, b = 0;
  if (h < 0) h = (h + 360);

  if (h <= 120.0) {
    r = ((120.0 - h) / 60.0);
    g = (h / 60.0);
    b = 0.0;
  }
  else if (h <= 240.0) {
    r = 0.0;
    g = ((240.0 - h) / 60.0);
    b = ((h - 120.0) / 60.0);
  }
  else if (h <= 360.0) {
    r = ((h - 240.0) / 60.0);
    g = 0.0;
    b = ((360.0 - h) / 60.0);
  }
  return new Array(clamp(rnd(r,5),0,1),
    clamp(rnd(g,5),0,1),clamp(rnd(b,5),0,1));

 return new Array(minimum(r,1),
    minimum(g,1),minimum(b,1));
}

/// HSV, hue 1 is a color, 0 = black
/// unless reversed input (1-r)
function hsv2rgb(h,s,v) {
  var vv = new Array(1,1,1);
  var color = h2rgb(h);
  color = multv(color, s);
  vv = multv(vv, (1 - s));
  color = addv(color,vv);
  color = multv(color,v);
/// STILL giving neg numbers - CLAMP!! tranlated from C which worked fine.
  color = clampv(color,0,1);
  return color;
}
function initcolopal(s,v) {
  // hsv sat and value initcolopal(1,.3);
nColors = 1920;
  HSV = 1;
  var z = 320, sat = s, light = v;
  var i = 0, j = 0, k = 0;
  var rgb = new Array(0,0,0);
  while (j < 3) {

    i = 0;
    while (i < z) {
      sat += .12 / z;
      light += .12 / z;
      rgb = hsv2rgb(1.0 - (i / z), sat, light);
      i++;
      drwpatch(k,Width,rgb); k++;
    }
    j++;
  }
  j = 0;
  sat = 1;
  light = .33;
  while (j < 3) {

    i = 1;
    while (i <= z) {
      sat += .12 / z;
      light += .12 / z;
      rgb = hsl2rgb(1.0 - (i / z), sat, light);
      drwpatch(k,Width,rgb); k++;
      i++;
// PROGESS
//if ((((i / z) * 10) % 2) == 0) e intr((i / z) * 100);
    }
    j++;
  }

GG.paint();
}

function drwpatch(i,w,rgb) {
  var sz = patchSize, c = "#000000";
  var color = multv(rgb,255);
  color[0] = intr(color[0]);
  color[1] = intr(color[1]);
  color[2] = intr(color[2]);
  c = RGB2Hex(color);
  // echoadd(i,color,RGB2Hex(color));
  // document.getElementById("colorname").value = i;
  var m = Math.floor(w/sz);
  var x = (i % m) * sz;
  var y = Math.floor(i / m) * sz;
  GG.setColor(c);
  GG.fillRect(x,y,sz,sz);
  GG.setColor("#FFFFFF");
if (i == nColors-1) GG.drawString(""+ (i+1),x+sz,y);
}
function rnd(num,deci) {
  with (Math) {
    return round(num*pow(10,deci)) / pow(10,deci);
} }
function _round(num,deci) {
  with (Math) {
    return round(num*pow(10,deci)) / pow(10,deci);
} }
function roundv(v,n) {
  return new Array(rnd(v[0],n),rnd(v[1],n),rnd(v[2],n));
}
function clampv(v,n,m) {
  vv = new Array(v[0],v[1],v[2]);
  if (v[0] < n) vv[0] = n;
  if (v[0] > m) vv[0] = m;
  if (v[1] < n) vv[1] = n;
  if (v[1] > m) vv[1] = m;
  if (v[2] < n) vv[2] = n;
  if (v[2] > m) vv[2] = m;
  return vv;
}
function addv(a,b) {
 return new Array(a[0]+b[0],a[1]+b[1],a[2]+b[2]);
}
function multv(a,b) {
 return new Array(a[0]*b,a[1]*b,a[2]*b);
}

function colorhue(i) {
  return "rgb";
}